require "import"
import "android.widget.*"
import "com.androlua.*"

-- ग्रिड लेआउट सेटअप
layout = {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill"
}

items = {"मराठी", "हिंदी"}
dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))
dlg.setTitle("भाषा का चयन करें")
dlg.setButton("बंद करें", nil)
dlg.show()

grid.onItemClick = function(l, v)
    dlg.dismiss()
    
    -- चयनित भाषा के लिए भाषा कोड सेट करना
    local languageCode = ""
    if v.text == "मराठी" then
        languageCode = "mr-IN"
    elseif v.text == "हिंदी" then
        languageCode = "hi-IN"
    end

    if languageCode ~= "" then
        require "import"
        import "android.content.Context"
        import "android.content.Intent"
        import "android.speech.SpeechRecognizer"
        import "android.speech.RecognitionListener"
        import "android.speech.RecognizerIntent"

        -- स्पीच रिकग्नाइज़र को समाप्त करने का फ़ंक्शन
        function destroySpeechRecognizer(rec)
            if rec then
                rec.destroy()
                rec = nil
            end
        end

        -- स्पीच रिकग्निशन शुरू करने का फ़ंक्शन
        function startSpeechRecognition()
            local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

            local recognitionListener = RecognitionListener {
                onResults = function(results)
                    local resultArray = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
                    if resultArray ~= nil and resultArray.size() > 0 then
                        local recognizedText = resultArray.get(0)
                        local editText = service.getEditText()
                        service.insertText(editText, recognizedText .. "। ")
                        service.speak(recognizedText)
                    end
                    destroySpeechRecognizer(speechRecognizer)
                end,
                onError = function()
                    destroySpeechRecognizer(speechRecognizer)
                end
            }

            local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
            recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
            recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, languageCode)
            recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
            speechRecognizer.setRecognitionListener(recognitionListener)
            speechRecognizer.startListening(recognizerIntent)
        end

        startSpeechRecognition()
    end
end